xfs: test inobtcount upgrade
[xfstests-dev.git] / common / xfs
index 37cd80c6c563b4c845697c5eef70c22126cd1707..a0721291f8f90cab98da0bdea73e74bcf2a823dd 100644 (file)
@@ -77,6 +77,69 @@ _scratch_mkfs_xfs_supported()
        return $mkfs_status
 }
 
+# Returns the minimum XFS log size, in units of log blocks.
+_scratch_find_xfs_min_logblocks()
+{
+       local mkfs_cmd="`_scratch_mkfs_xfs_opts`"
+
+       # The smallest log size we can specify is 2M (XFS_MIN_LOG_BYTES) so
+       # pass that in and see if mkfs succeeds or tells us what is the
+       # minimum log size.
+       local XFS_MIN_LOG_BYTES=2097152
+
+       # Try formatting the filesystem with all the options given and the
+       # minimum log size.  We hope either that this succeeds or that mkfs
+       # tells us the required minimum log size for the feature set.
+       #
+       # We cannot use _scratch_do_mkfs because it will retry /any/ failed
+       # mkfs with MKFS_OPTIONS removed even if the only "failure" was that
+       # the log was too small.
+       local extra_mkfs_options="$* -N -l size=$XFS_MIN_LOG_BYTES"
+       eval "$mkfs_cmd $MKFS_OPTIONS $extra_mkfs_options $SCRATCH_DEV" \
+               2>$tmp.mkfserr 1>$tmp.mkfsstd
+       local mkfs_status=$?
+
+       # If the format fails for a reason other than the log being too small,
+       # try again without MKFS_OPTIONS because that's what _scratch_do_mkfs
+       # will do if we pass in the log size option.
+       if [ $mkfs_status -ne 0 ] &&
+          ! egrep -q '(log size.*too small, minimum|external log device.*too small, must be)' $tmp.mkfserr; then
+               eval "$mkfs_cmd $extra_mkfs_options $SCRATCH_DEV" \
+                       2>$tmp.mkfserr 1>$tmp.mkfsstd
+               mkfs_status=$?
+       fi
+
+       # mkfs suceeded, so we must pick out the log block size to do the
+       # unit conversion
+       if [ $mkfs_status -eq 0 ]; then
+               blksz="$(grep '^log.*bsize' $tmp.mkfsstd | \
+                       sed -e 's/log.*bsize=\([0-9]*\).*$/\1/g')"
+               echo $((XFS_MIN_LOG_BYTES / blksz))
+               rm -f $tmp.mkfsstd $tmp.mkfserr
+               return
+       fi
+
+       # Usually mkfs will tell us the minimum log size...
+       if grep -q 'minimum size is' $tmp.mkfserr; then
+               grep 'minimum size is' $tmp.mkfserr | \
+                       sed -e 's/^.*minimum size is \([0-9]*\) blocks/\1/g'
+               rm -f $tmp.mkfsstd $tmp.mkfserr
+               return
+       fi
+       if grep -q 'external log device.*too small, must be' $tmp.mkfserr; then
+               grep 'external log device.*too small, must be' $tmp.mkfserr | \
+                       sed -e 's/^.*must be at least \([0-9]*\) blocks/\1/g'
+               rm -f $tmp.mkfsstd $tmp.mkfserr
+               return
+       fi
+
+       # Don't know what to do, so fail
+       echo "Cannot determine minimum log size" >&2
+       cat $tmp.mkfsstd >> $seqres.full
+       cat $tmp.mkfserr >> $seqres.full
+       rm -f $tmp.mkfsstd $tmp.mkfserr
+}
+
 _scratch_mkfs_xfs()
 {
        local mkfs_cmd="`_scratch_mkfs_xfs_opts`"
@@ -89,6 +152,7 @@ _scratch_mkfs_xfs()
        _scratch_do_mkfs "$mkfs_cmd" "$mkfs_filter" $* 2>$tmp.mkfserr 1>$tmp.mkfsstd
        mkfs_status=$?
 
+       grep -q crc=0 $tmp.mkfsstd && _force_xfsv4_mount_options
 
        if [ $mkfs_status -eq 0 -a "$LARGE_SCRATCH_DEV" = yes ]; then
                # manually parse the mkfs output to get the fs size in bytes
@@ -110,6 +174,35 @@ _scratch_mkfs_xfs()
        return $mkfs_status
 }
 
+# Get the size of an allocation unit of a file.  Normally this is just the
+# block size of the file, but for realtime files, this is the realtime extent
+# size.
+_xfs_get_file_block_size()
+{
+       local path="$1"
+
+       if ! ($XFS_IO_PROG -c "stat -v" "$path" 2>&1 | egrep -q '(rt-inherit|realtime)'); then
+               _get_block_size "$path"
+               return
+       fi
+
+       # Otherwise, call xfs_info until we find a mount point or the root.
+       path="$(readlink -m "$path")"
+       while ! $XFS_INFO_PROG "$path" &>/dev/null && [ "$path" != "/" ]; do
+               path="$(dirname "$path")"
+       done
+       $XFS_INFO_PROG "$path" | grep realtime | sed -e 's/^.*extsz=\([0-9]*\).*$/\1/g'
+}
+
+_xfs_get_fsxattr()
+{
+       local field="$1"
+       local path="$2"
+
+       local value=$($XFS_IO_PROG -c "stat" "$path" | grep -w "$field")
+       echo ${value##fsxattr.${field} = }
+}
+
 # xfs_check script is planned to be deprecated. But, we want to
 # be able to invoke "xfs_check" behavior in xfstests in order to
 # maintain the current verification levels.
@@ -160,6 +253,39 @@ _scratch_xfs_db()
        $XFS_DB_PROG "$@" $(_scratch_xfs_db_options)
 }
 
+_test_xfs_db_options()
+{
+       TEST_OPTIONS=""
+       [ "$USE_EXTERNAL" = yes -a ! -z "$TEST_LOGDEV" ] && \
+               TEST_OPTIONS="-l$TEST_LOGDEV"
+       echo $TEST_OPTIONS $* $TEST_DEV
+}
+
+_test_xfs_db()
+{
+       $XFS_DB_PROG "$@" $(_test_xfs_db_options)
+}
+
+_scratch_xfs_admin()
+{
+       local options=("$SCRATCH_DEV")
+       local rt_opts=()
+       [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
+               options+=("$SCRATCH_LOGDEV")
+       if [ "$USE_EXTERNAL" = yes ] && [ -n "$SCRATCH_RTDEV" ]; then
+               $XFS_ADMIN_PROG --help 2>&1 | grep -q 'rtdev' || \
+                       _notrun 'xfs_admin does not support rt devices'
+               rt_opts+=(-r "$SCRATCH_RTDEV")
+       fi
+
+       # xfs_admin in xfsprogs 5.11 has a bug where an external log device
+       # forces xfs_db to be invoked, potentially with zero command arguments.
+       # When this happens, xfs_db will wait for input on stdin, which causes
+       # fstests to hang.  Since xfs_admin is not an interactive tool, we
+       # can redirect stdin from /dev/null to prevent this issue.
+       $XFS_ADMIN_PROG "${rt_opts[@]}" "$@" "${options[@]}" < /dev/null
+}
+
 _scratch_xfs_logprint()
 {
        SCRATCH_OPTIONS=""
@@ -186,6 +312,14 @@ _scratch_xfs_check()
        _xfs_check $SCRATCH_OPTIONS $* $SCRATCH_DEV
 }
 
+# Check for secret debugging hooks in xfs_repair
+_require_libxfs_debug_flag() {
+       local hook="$1"
+
+       grep -q "$hook" "$(type -P xfs_repair)" || \
+               _notrun "libxfs debug hook $hook not detected?"
+}
+
 _scratch_xfs_repair()
 {
        SCRATCH_OPTIONS=""
@@ -193,7 +327,6 @@ _scratch_xfs_repair()
                SCRATCH_OPTIONS="-l$SCRATCH_LOGDEV"
        [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_RTDEV" ] && \
                SCRATCH_OPTIONS=$SCRATCH_OPTIONS" -r$SCRATCH_RTDEV"
-       [ "$LARGE_SCRATCH_DEV" = yes ] && SCRATCH_OPTIONS=$SCRATCH_OPTIONS" -t"
        $XFS_REPAIR_PROG $SCRATCH_OPTIONS $* $SCRATCH_DEV
 }
 
@@ -236,7 +369,7 @@ _require_scratch_xfs_crc()
        _scratch_mkfs_xfs >/dev/null 2>&1
        _try_scratch_mount >/dev/null 2>&1 \
           || _notrun "Kernel doesn't support crc feature"
-       xfs_info $SCRATCH_MNT | grep -q 'crc=1' || _notrun "crc feature not supported by this filesystem"
+       $XFS_INFO_PROG $SCRATCH_MNT | grep -q 'crc=1' || _notrun "crc feature not supported by this filesystem"
        _scratch_unmount
 }
 
@@ -295,6 +428,7 @@ _require_xfs_db_command()
        fi
        command=$1
 
+       _scratch_mkfs_xfs >/dev/null 2>&1
        _scratch_xfs_db -x -c "help" | grep $command > /dev/null || \
                _notrun "xfs_db $command support is missing"
 }
@@ -305,9 +439,13 @@ _supports_xfs_scrub()
        local mountpoint="$1"
        local device="$2"
 
-       if [ ! -b "$device" ] || [ ! -e "$mountpoint" ]; then
+       if [ -z "$device" ] || [ -z "$mountpoint" ]; then
                echo "Usage: _supports_xfs_scrub mountpoint device"
-               exit 1
+               return 1
+       fi
+
+       if [ ! -b "$device" ] || [ ! -e "$mountpoint" ]; then
+               return 1
        fi
 
        test "$FSTYP" = "xfs" || return 1
@@ -323,6 +461,40 @@ _supports_xfs_scrub()
        return 0
 }
 
+# Save a snapshot of a corrupt xfs filesystem for later debugging.
+_xfs_metadump() {
+       local metadump="$1"
+       local device="$2"
+       local logdev="$3"
+       local compressopt="$4"
+       shift; shift; shift; shift
+       local options="$@"
+       test -z "$options" && options="-a -o"
+
+       if [ "$logdev" != "none" ]; then
+               options="$options -l $logdev"
+       fi
+
+       $XFS_METADUMP_PROG $options "$device" "$metadump"
+       res=$?
+       [ "$compressopt" = "compress" ] && [ -n "$DUMP_COMPRESSOR" ] &&
+               $DUMP_COMPRESSOR "$metadump" &> /dev/null
+       return $res
+}
+
+# Snapshot the metadata on the scratch device
+_scratch_xfs_metadump()
+{
+       local metadump=$1
+       shift
+       local logdev=none
+
+       [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
+               logdev=$SCRATCH_LOGDEV
+
+       _xfs_metadump "$metadump" "$SCRATCH_DEV" "$logdev" nocompress "$@"
+}
+
 # run xfs_check and friends on a FS.
 _check_xfs_filesystem()
 {
@@ -339,14 +511,16 @@ _check_xfs_filesystem()
                extra_options="-f"
        fi
 
-       if [ "$2" != "none" ]; then
-               extra_log_options="-l$2"
-               extra_mount_options="-ologdev=$2"
+       local logdev="$2"
+       if [ "$logdev" != "none" ]; then
+               extra_log_options="-l$logdev"
+               extra_mount_options="-ologdev=$logdev"
        fi
 
-       if [ "$3" != "none" ]; then
-               extra_rt_options="-r$3"
-               extra_mount_options=$extra_mount_options" -ortdev=$3"
+       local rtdev="$3"
+       if [ "$rtdev" != "none" ]; then
+               extra_rt_options="-r$rtdev"
+               extra_mount_options=$extra_mount_options" -ortdev=$rtdev"
        fi
        extra_mount_options=$extra_mount_options" $MOUNT_OPTIONS"
 
@@ -358,7 +532,18 @@ _check_xfs_filesystem()
        # Run online scrub if we can.
        mntpt="$(_is_dev_mounted $device)"
        if [ -n "$mntpt" ] && _supports_xfs_scrub "$mntpt" "$device"; then
-               "$XFS_SCRUB_PROG" $scrubflag -v -d -n $device > $tmp.scrub 2>&1
+               # Tests can create a scenario in which a call to syncfs() issued
+               # at the end of the execution of the test script would return an
+               # error code. xfs_scrub internally calls syncfs() before
+               # starting the actual online consistency check operation. Since
+               # such a call to syncfs() fails, xfs_scrub ends up returning
+               # without performing consistency checks on the test
+               # filesystem. This can mask a possible on-disk data structure
+               # corruption. Hence consume such a possible syncfs() failure
+               # before executing a scrub operation.
+               $XFS_IO_PROG -c syncfs $mntpt >> $seqres.full 2>&1
+
+               "$XFS_SCRUB_PROG" $scrubflag -v -d -n $mntpt > $tmp.scrub 2>&1
                if [ $? -ne 0 ]; then
                        _log_err "_check_xfs_filesystem: filesystem on $device failed scrub"
                        echo "*** xfs_scrub $scrubflag -v -d -n output ***" >> $seqres.full
@@ -376,7 +561,7 @@ _check_xfs_filesystem()
 
        $XFS_LOGPRINT_PROG -t $extra_log_options $device 2>&1 \
                | tee $tmp.logprint | grep -q "<CLEAN>"
-       if [ $? -ne 0 -a "$HOSTOS" = "Linux" ]; then
+       if [ $? -ne 0 ]; then
                _log_err "_check_xfs_filesystem: filesystem on $device has dirty log"
                echo "*** xfs_logprint -t output ***"   >>$seqres.full
                cat $tmp.logprint                       >>$seqres.full
@@ -389,8 +574,7 @@ _check_xfs_filesystem()
        # option (-t) to avoid indexing the free space trees doesn't make it pass on
        # large filesystems. Avoid it.
        if [ "$LARGE_SCRATCH_DEV" != yes ]; then
-               _xfs_check $extra_log_options $device 2>&1 |\
-                       _fix_malloc >$tmp.fs_check
+               _xfs_check $extra_log_options $device 2>&1 > $tmp.fs_check
        fi
        if [ -s $tmp.fs_check ]; then
                _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (c)"
@@ -405,23 +589,31 @@ _check_xfs_filesystem()
        if [ $? -ne 0 ]; then
                _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (r)"
                echo "*** xfs_repair -n output ***"     >>$seqres.full
-               cat $tmp.repair | _fix_malloc           >>$seqres.full
+               cat $tmp.repair                         >>$seqres.full
                echo "*** end xfs_repair output"        >>$seqres.full
 
                ok=0
        fi
        rm -f $tmp.fs_check $tmp.logprint $tmp.repair
 
+       if [ "$ok" -ne 1 ] && [ "$DUMP_CORRUPT_FS" = "1" ]; then
+               local flatdev="$(basename "$device")"
+               _xfs_metadump "$seqres.$flatdev.check.md" "$device" "$logdev" \
+                       compress >> $seqres.full
+       fi
+
        # Optionally test the index rebuilding behavior.
        if [ -n "$TEST_XFS_REPAIR_REBUILD" ]; then
+               rebuild_ok=1
                $XFS_REPAIR_PROG $extra_options $extra_log_options $extra_rt_options $device >$tmp.repair 2>&1
                if [ $? -ne 0 ]; then
                        _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (rebuild)"
                        echo "*** xfs_repair output ***"        >>$seqres.full
-                       cat $tmp.repair | _fix_malloc           >>$seqres.full
+                       cat $tmp.repair                         >>$seqres.full
                        echo "*** end xfs_repair output"        >>$seqres.full
 
                        ok=0
+                       rebuild_ok=0
                fi
                rm -f $tmp.repair
 
@@ -429,12 +621,19 @@ _check_xfs_filesystem()
                if [ $? -ne 0 ]; then
                        _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (rebuild-reverify)"
                        echo "*** xfs_repair -n output ***"     >>$seqres.full
-                       cat $tmp.repair | _fix_malloc           >>$seqres.full
+                       cat $tmp.repair                         >>$seqres.full
                        echo "*** end xfs_repair output"        >>$seqres.full
 
                        ok=0
+                       rebuild_ok=0
                fi
                rm -f $tmp.repair
+
+               if [ "$rebuild_ok" -ne 1 ] && [ "$DUMP_CORRUPT_FS" = "1" ]; then
+                       local flatdev="$(basename "$device")"
+                       _xfs_metadump "$seqres.$flatdev.rebuild.md" "$device" \
+                               "$logdev" compress >> $seqres.full
+               fi
        fi
 
        if [ $ok -eq 0 ]; then
@@ -474,7 +673,7 @@ _require_xfs_test_rmapbt()
 {
        _require_test
 
-       if [ "$(xfs_info "$TEST_DIR" | grep -c "rmapbt=1")" -ne 1 ]; then
+       if [ "$($XFS_INFO_PROG "$TEST_DIR" | grep -c "rmapbt=1")" -ne 1 ]; then
                _notrun "rmapbt not supported by test filesystem type: $FSTYP"
        fi
 }
@@ -485,7 +684,7 @@ _require_xfs_scratch_rmapbt()
 
        _scratch_mkfs > /dev/null
        _scratch_mount
-       if [ "$(xfs_info "$SCRATCH_MNT" | grep -c "rmapbt=1")" -ne 1 ]; then
+       if [ "$($XFS_INFO_PROG "$SCRATCH_MNT" | grep -c "rmapbt=1")" -ne 1 ]; then
                _scratch_unmount
                _notrun "rmapbt not supported by scratch filesystem type: $FSTYP"
        fi
@@ -612,6 +811,16 @@ _require_xfs_mkfs_ciname()
                || _notrun "need case-insensitive naming support in mkfs.xfs"
 }
 
+# this test requires mkfs.xfs have configuration file support
+_require_xfs_mkfs_cfgfile()
+{
+       echo > /tmp/a
+       _scratch_mkfs_xfs_supported -c options=/tmp/a >/dev/null 2>&1
+       res=$?
+       rm -rf /tmp/a
+       test $res -eq 0 || _notrun "need configuration file support in mkfs.xfs"
+}
+
 # XFS_DEBUG requirements
 _require_xfs_debug()
 {
@@ -697,3 +906,263 @@ _scratch_xfs_set_sb_field()
 {
        _scratch_xfs_set_metadata_field "$1" "$2" "sb 0"
 }
+
+# Before xfsprogs commit 4222d000ed("db: write via array indexing doesn't
+# work"), xfs_db command to write a specific AGFL index doesn't work. It's a
+# bug in a diagnostic tool that is only used by XFS developers as a test
+# infrastructure, so it's fine to treat it as a infrastructure dependency as
+# all other _require rules.
+_require_xfs_db_write_array()
+{
+       local supported=0
+
+       _require_test
+       touch $TEST_DIR/$seq.img
+       $MKFS_XFS_PROG -d file,name=$TEST_DIR/$seq.img,size=512m >/dev/null 2>&1
+       $XFS_DB_PROG -x -c "agfl 0" -c "write bno[32] 78" $TEST_DIR/$seq.img \
+               >/dev/null 2>&1
+       $XFS_DB_PROG -x -c "agfl 0" -c "print bno[32]" $TEST_DIR/$seq.img \
+               | grep -q "bno\[32\] = 78" && supported=1
+       rm -f $TEST_DIR/$seq.img
+       [ $supported -eq 0 ] && _notrun "xfs_db write can't support array"
+}
+
+_require_xfs_spaceman_command()
+{
+       if [ -z "$1" ]; then
+               echo "Usage: _require_xfs_spaceman_command command [switch]" 1>&2
+               exit 1
+       fi
+       local command=$1
+       shift
+       local param="$*"
+       local param_checked=0
+       local opts=""
+
+       _require_command "$XFS_SPACEMAN_PROG" "xfs_spaceman"
+
+       testfile=$TEST_DIR/$$.xfs_spaceman
+       touch $testfile
+       case $command in
+       "health")
+               testio=`$XFS_SPACEMAN_PROG -c "health $param" $TEST_DIR 2>&1`
+               param_checked=1
+               ;;
+       *)
+               testio=`$XFS_SPACEMAN_PROG -c "help $command" $TEST_DIR 2>&1`
+       esac
+
+       rm -f $testfile 2>&1 > /dev/null
+       echo $testio | grep -q "not found" && \
+               _notrun "xfs_spaceman $command support is missing"
+       echo $testio | grep -q "Operation not supported" && \
+               _notrun "xfs_spaceman $command failed (old kernel/wrong fs?)"
+       echo $testio | grep -q "Invalid" && \
+               _notrun "xfs_spaceman $command failed (old kernel/wrong fs/bad args?)"
+       echo $testio | grep -q "foreign file active" && \
+               _notrun "xfs_spaceman $command not supported on $FSTYP"
+       echo $testio | grep -q "Inappropriate ioctl for device" && \
+               _notrun "xfs_spaceman $command support is missing (missing ioctl?)"
+       echo $testio | grep -q "Function not implemented" && \
+               _notrun "xfs_spaceman $command support is missing (missing syscall?)"
+
+       [ -n "$param" ] || return
+
+       if [ $param_checked -eq 0 ]; then
+               $XFS_SPACEMAN_PROG -c "help $command" | grep -q "^ $param --" || \
+                       _notrun "xfs_spaceman $command doesn't support $param"
+       fi
+}
+
+_scratch_get_sfdir_prefix() {
+       local dir_ino="$1"
+
+       for prefix in "u.sfdir3" "u.sfdir2" "u3.sfdir3"; do
+               if [ -n "$(_scratch_xfs_get_metadata_field \
+                               "${prefix}.hdr.parent.i4" \
+                               "inode ${dir_ino}")" ]; then
+                       echo "${prefix}"
+                       return 0
+               fi
+       done
+       _scratch_xfs_db -c "inode ${dir_ino}" -c 'p' >> $seqres.full
+       return 1
+}
+
+_scratch_get_bmx_prefix() {
+       local ino="$1"
+
+       for prefix in "u3.bmx" "u.bmx"; do
+               if [ -n "$(_scratch_xfs_get_metadata_field \
+                               "${prefix}[0].startblock" \
+                               "inode ${ino}")" ]; then
+                       echo "${prefix}"
+                       return 0
+               fi
+       done
+       _scratch_xfs_db -c "inode ${ino}" -c 'p' >> $seqres.full
+       return 1
+}
+
+_scratch_get_iext_count()
+{
+       local ino=$1
+       local whichfork=$2
+       local field=""
+
+       case $whichfork in
+               "attr")
+                       field=core.naextents
+                       ;;
+               "data")
+                       field=core.nextents
+                       ;;
+               *)
+                       return 1
+       esac
+
+       _scratch_xfs_get_metadata_field $field "inode $ino"
+}
+
+#
+# Ensures that we don't pass any mount options incompatible with XFS v4
+#
+_force_xfsv4_mount_options()
+{
+       local gquota=0
+       local pquota=0
+
+       # Can't have group and project quotas in XFS v4
+       echo "$MOUNT_OPTIONS" | egrep -q "(gquota|grpquota|grpjquota=|gqnoenforce)" && gquota=1
+       echo "$MOUNT_OPTIONS" | egrep -q "(\bpquota|prjquota|pqnoenforce)" && pquota=1
+
+       if [ $gquota -gt 0 ] && [ $pquota -gt 0 ]; then
+               export MOUNT_OPTIONS=$(echo $MOUNT_OPTIONS \
+                       | sed   -e 's/gquota/QUOTA/g'      \
+                               -e 's/grpquota/QUOTA/g'    \
+                               -e 's/grpjquota=[^, ]/QUOTA/g' \
+                               -e 's/gqnoenforce/QUOTA/g' \
+                               -e "s/QUOTA/defaults/g")
+       fi
+       echo "MOUNT_OPTIONS = $MOUNT_OPTIONS" >>$seqres.full
+}
+
+# Find AG count of mounted filesystem
+_xfs_mount_agcount()
+{
+       $XFS_INFO_PROG "$1" | grep agcount= | sed -e 's/^.*agcount=\([0-9]*\),.*$/\1/g'
+}
+
+# Wipe the superblock of each XFS AGs
+_try_wipe_scratch_xfs()
+{
+       local num='^[0-9]+$'
+       local agcount
+       local agsize
+       local dbsize
+
+       # Try to wipe each SB if there's an existed XFS
+       agcount=`_scratch_xfs_get_sb_field agcount 2>/dev/null`
+       agsize=`_scratch_xfs_get_sb_field agblocks 2>/dev/null`
+       dbsize=`_scratch_xfs_get_sb_field blocksize 2>/dev/null`
+       if [[ $agcount =~ $num && $agsize =~ $num && $dbsize =~ $num ]];then
+               for ((i = 0; i < agcount; i++)); do
+                       $XFS_IO_PROG -c "pwrite $((i * dbsize * agsize)) $dbsize" \
+                               $SCRATCH_DEV >/dev/null;
+               done
+       fi
+
+       # Try to wipe each SB by default mkfs.xfs geometry
+       local tmp=`mktemp -u`
+       unset agcount agsize dbsize
+       _scratch_mkfs_xfs -N 2>/dev/null | perl -ne '
+               if (/^meta-data=.*\s+agcount=(\d+), agsize=(\d+) blks/) {
+                       print STDOUT "agcount=$1\nagsize=$2\n";
+               }
+               if (/^data\s+=\s+bsize=(\d+)\s/) {
+                       print STDOUT "dbsize=$1\n";
+               }' > $tmp.mkfs
+
+       . $tmp.mkfs
+       if [[ $agcount =~ $num && $agsize =~ $num && $dbsize =~ $num ]];then
+               for ((i = 0; i < agcount; i++)); do
+                       $XFS_IO_PROG -c "pwrite $((i * dbsize * agsize)) $dbsize" \
+                               $SCRATCH_DEV >/dev/null;
+               done
+       fi
+       rm -f $tmp.mkfs
+}
+
+_require_xfs_copy()
+{
+       [ -n "$XFS_COPY_PROG" ] || _notrun "xfs_copy binary not yet installed"
+       [ "$USE_EXTERNAL" = yes ] && \
+               _notrun "Cannot xfs_copy with external devices"
+}
+
+__xfs_cowgc_interval_knob1="/proc/sys/fs/xfs/speculative_cow_prealloc_lifetime"
+__xfs_cowgc_interval_knob2="/proc/sys/fs/xfs/speculative_prealloc_lifetime"
+
+_xfs_set_cowgc_interval() {
+       if [ -w $__xfs_cowgc_interval_knob1 ]; then
+               echo "$@" > $__xfs_cowgc_interval_knob1
+       elif [ -w $__xfs_cowgc_interval_knob2 ]; then
+               echo "$@" > $__xfs_cowgc_interval_knob2
+       else
+               _fail "Can't find cowgc interval procfs knob?"
+       fi
+}
+
+_xfs_get_cowgc_interval() {
+       if [ -w $__xfs_cowgc_interval_knob1 ]; then
+               cat $__xfs_cowgc_interval_knob1
+       elif [ -w $__xfs_cowgc_interval_knob2 ]; then
+               cat $__xfs_cowgc_interval_knob2
+       else
+               _fail "Can't find cowgc interval procfs knob?"
+       fi
+}
+
+# Print the status of the given features on the scratch filesystem.
+# Returns 0 if all features are found, 1 otherwise.
+_check_scratch_xfs_features()
+{
+       local features="$(_scratch_xfs_db -c 'version')"
+       local output=("FEATURES:")
+       local found=0
+
+       for feature in "$@"; do
+               local status="NO"
+               if echo "${features}" | grep -q -w "${feature}"; then
+                       status="YES"
+                       found=$((found + 1))
+               fi
+               output+=("${feature}:${status}")
+       done
+
+       echo "${output[@]}"
+       test "${found}" -eq "$#"
+}
+
+# Decide if xfs_repair knows how to set (or clear) a filesystem feature.
+_require_xfs_repair_upgrade()
+{
+       local type="$1"
+
+       $XFS_REPAIR_PROG -c "$type=garbagevalue" 2>&1 | \
+               grep -q 'unknown option' && \
+               _notrun "xfs_repair does not support upgrading fs with $type"
+}
+
+# Require that the scratch device exists, that mkfs can format with inobtcount
+# enabled, and that the kernel can mount such a filesystem.
+_require_scratch_xfs_inobtcount()
+{
+       _require_scratch
+
+       _scratch_mkfs -m inobtcount=1 &> /dev/null || \
+               _notrun "mkfs.xfs doesn't support inobtcount feature"
+       _try_scratch_mount || \
+               _notrun "kernel doesn't support xfs inobtcount feature"
+       _scratch_unmount
+}